
class Cluster{
  ArrayList<Point> points;
  Point origin;
  color C;
  int w;
  
  Cluster(){
    origin = new Point();
    points = new ArrayList<Point>();
    C = color(random(255),random(255),random(255));
    w = (int)random(50,100);
  }

  void add(Point p){
    points.add(p);
  }
  
  void clear(){
    points.clear();
  }
  
  void attract(){
    for(int i = 0; i < points.size(); i++){
      origin.pos.add(points.get(i).pos);
    }
    origin.pos.div(points.size());
  }
  
  void draw(){
    noFill();
    stroke(C);
    
    println(origin.pos);
    ellipse(origin.pos.x, origin.pos.y, w,w);
  }
  
}

class ClusterEngine{
  ArrayList<Cluster> clusters;
  ArrayList<Point> clusterOrigins;
  ArrayList<Point> data;

  ClusterEngine(int k){
    clusterOrigins = new ArrayList<Point>();    
    clusters = new ArrayList<Cluster>();
    data = new ArrayList<Point>();    
    
    for(int i = 0; i < k; i++){
      clusters.add(new Cluster());
      clusterOrigins.add(clusters.get(i).origin);
    }
  }
  
  void resetCluster(){
    clusterOrigins.clear();
    for(int i = 0; i < clusters.size(); i++){
      clusters.get(i).clear();
      clusterOrigins.add(clusters.get(i).origin);
    }
  }
  
  void store(PVector dataPoint){
    data.add(new Point(dataPoint));
    if(data.size() > N){
      data.remove(0); 
    }
  }
  
  void store(Point dataPoint){
    data.add(dataPoint);
    if(data.size() > N){
      data.remove(0); 
    }
  }
  
 
  void compute(int n){
    resetCluster();
    for(int i = 0; i < n; i++){
      
      for(int j = 0; j < data.size(); j++){
        int index = data.get(j).findClosest(clusterOrigins);//.pos.add(data.get(j).pos);
        clusters.get(index).add(data.get(j));
      }
      for(int j = 0; j < clusters.size(); j++){
        if(clusters.get(j).points.size() > 0)clusters.get(j).attract();
      }
      
    }
  }
  
  
  void draw(){
    for(int i = 0; i < data.size(); i++){
      strokeWeight(2);
      stroke(255,0,0);
      data.get(i).draw();
    }
    
    for(int i = 0; i < clusters.size(); i++){
      clusters.get(i).draw();    
    }
  }
  
  
  
}
